import Vue from "vue";
import Vuex from "vuex";
import createPersistedState from "vuex-persistedstate";
import VueRouter from "vue-router";
import App from "./App.vue";
import VueAxios from "vue-axios";
import axios from "axios";


import HomeComponent from "./components/HomeComponent.vue";
import SchoolManager from "./components/SchoolManager.vue";
import MentionsLegales from "./components/MentionsLegales.vue";
import Login from "./components/Login.vue";
import Register from "./components/Register.vue";
import Encoder from "./components/Encoder.vue";
import ResultsDisplay from "./components/ResultsDisplay.vue";
require("@/assets/main.scss");
import "@fortawesome/fontawesome-free/css/all.css";
import "@fortawesome/fontawesome-free/js/all.js";

Vue.use(VueRouter);
Vue.use(Vuex);
Vue.use(VueAxios, axios);

Vue.config.productionTip = false;


const routes = [
  {
    name: "home",
    path: "/",
    component: HomeComponent
  },
  {
    name: "resultsDisplay",
    path: "/results",
    component: ResultsDisplay
  },
  {
    name: "encoder",
    path: "/encoder",
    component: Encoder
  },
  {
    name: "schoolManager",
    path: "/school",
    component: SchoolManager
  },
  {
    name: "mentionsLegales",
    path: "/legal",
    component: MentionsLegales
  },
  {
    name: "register",
    path: "/register",
    component: Register
  },
  {
    name: "login",
    path: "/login",
    component: Login
  }
];

const store = new Vuex.Store({
  state: {
    isLoggedIn: false,
    schoolName: "school-name"
  },
  mutations: {
    login(state, user) {
      state.isLoggedIn = true;
      state.schoolName = user.schoolName;
    },
    logout(state) {
      state.isLoggedIn = false;
      state.schoolName = "school-name";
    }
  },
  plugins: [createPersistedState()]
});

const router = new VueRouter({ base: "", mode: "history", routes: routes });

new Vue(Vue.util.extend({ router, store }, App)).$mount("#app");
