const express = require('express');

let Team = require('./team.model')
let Puzzle = require('./puzzle.model')

const router = express.Router();

router.route('/addTeam').post(function (req, res) {
  if (req.user) {
    let team = new Team(req.body)
    team.schoolUser = req.user.username
    team.cardId = "";
    console.log("Trying to add team :", team)
    team.save().then(() => {
      res.status(200).json({'business': 'business in added successfully'});
    })
    .catch(() => {
      res.status(400).send("unable to save to database");
    });
  }
  
})

router.route('/').get(function (req, res) {
  if (req.user) {
    console.log("GETing school for :", req.user.username)
    Team.find({schoolUser: req.user.username}, function (err, teams) {
      if (err) {res.json(err)}
      else {res.json(teams)}
    });
  }
  
});

router.route('/deleteTeam/:id').delete(function (req, res) {
  Team.findByIdAndRemove({_id: req.params.id}, function(err){
      if(err) res.json(err);
      else {
        res.json('Successfully removed');
        console.log('Removed team');
      }
  });
});
//TODO allow operation only if logged in
router.route('/updateTeamCard/:id').post(function (req, res) {
  if (req.user) {
    console.log("Request for updating card ID :", req.body.cardId);
    Team.count({schoolUser: req.user.username, cardId: req.body.cardId}, (err, count) => {
      if (err) res.json(err);
      else {
        if (count > 0) {
          res.status(500).json({error : "Alredy an user with this card"})
        }
        else {
          Team.updateOne({_id: req.params.id, schoolUser: req.user.username}, {cardId: req.body.cardId}, function(err){
            if(err) res.json(err);
            else {
              res.json('Successfully updated card ID');
              console.log('Updated team card')
            }
          });
        }
      }
    })
    
  }
});

router.route('/getTeamByCardID/:cardId').get(function (req, res) {
    console.log("GETing team for :", req.params.cardId)
    Team.find({cardId: req.params.cardId}, function (err, team) {
      if (err) {res.json(err)}
      else {res.json(team)}
    });
});

router.route('/removeTeamCard/:id').post(function (req, res) {
  if (req.user) {
    console.log("Request for removing card ID")
    Team.updateOne({_id: req.params.id, schoolUser: req.user.username}, {$unset: {cardId: ""}}, function(err){
      if(err) res.json(err);
      else {
        res.json('Successfully removed card ID');
        console.log('Updated team card')
      }
    });
  }  
});

router.route('/updateTeamPuzzles/:cardId').post(function (req, res) {
  /*var puzzles = []
  for (puzzle in req.body) {
    puzzles.push(new Puzzle(puzzle))
  }*/
  console.log("Request for updating puzzles :", req.body);
  Team.updateOne({cardId: req.params.cardId /*, schoolUser: req.user.username*/}, {donePuzzles : req.body} , function(err){
      if(err) res.json(err);
      else res.json('Successfully updated puzzles');
  });
});

module.exports = router;